package cn.ibizlab.assetmanagement.core.asset.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.assetmanagement.util.domain.EntityBase;
import cn.ibizlab.assetmanagement.util.annotation.DEField;
import cn.ibizlab.assetmanagement.util.enums.DEPredefinedFieldType;
import cn.ibizlab.assetmanagement.util.enums.DEFieldDefaultValueType;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.assetmanagement.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.assetmanagement.util.domain.EntityMP;

/**
 * 实体[文档]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "EAMDOCUMENT",resultMap = "EAMDocumentResultMap")
public class EAMDocument extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 建立时间
     */
    @DEField(preType = DEPredefinedFieldType.CREATEDATE)
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "createdate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("createdate")
    private Timestamp createdate;
    /**
     * 文档名称
     */
    @TableField(value = "eamdocumentname")
    @JSONField(name = "eamdocumentname")
    @JsonProperty("eamdocumentname")
    private String eamdocumentname;
    /**
     * 建立人
     */
    @DEField(preType = DEPredefinedFieldType.CREATEMAN)
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @JSONField(name = "createman")
    @JsonProperty("createman")
    private String createman;
    /**
     * 文档标识
     */
    @DEField(isKeyField=true)
    @TableId(value= "eamdocumentid",type=IdType.ASSIGN_UUID)
    @JSONField(name = "eamdocumentid")
    @JsonProperty("eamdocumentid")
    private String eamdocumentid;
    /**
     * 更新时间
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEDATE)
    @TableField(value = "updatedate")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    @JSONField(name = "updatedate" , format="yyyy-MM-dd HH:mm:ss")
    @JsonProperty("updatedate")
    private Timestamp updatedate;
    /**
     * 更新人
     */
    @DEField(preType = DEPredefinedFieldType.UPDATEMAN)
    @TableField(value = "updateman")
    @JSONField(name = "updateman")
    @JsonProperty("updateman")
    private String updateman;
    /**
     * 资产类型标识
     */
    @TableField(value = "eamassettypeid")
    @JSONField(name = "eamassettypeid")
    @JsonProperty("eamassettypeid")
    private String eamassettypeid;
    /**
     * 资产类型
     */
    @TableField(exist = false)
    @JSONField(name = "eamassettypename")
    @JsonProperty("eamassettypename")
    private String eamassettypename;
    /**
     * 文档编号
     */
    @TableField(value = "documentnumber")
    @JSONField(name = "documentnumber")
    @JsonProperty("documentnumber")
    private String documentnumber;
    /**
     * 文档类型标识
     */
    @TableField(value = "eamdocumenttypeid")
    @JSONField(name = "eamdocumenttypeid")
    @JsonProperty("eamdocumenttypeid")
    private String eamdocumenttypeid;
    /**
     * 文档类型
     */
    @TableField(exist = false)
    @JSONField(name = "eamdocumenttypename")
    @JsonProperty("eamdocumenttypename")
    private String eamdocumenttypename;
    /**
     * 内容
     */
    @TableField(value = "content")
    @JSONField(name = "content")
    @JsonProperty("content")
    private String content;
    /**
     * 文件
     */
    @TableField(value = "docfile")
    @JSONField(name = "docfile")
    @JsonProperty("docfile")
    private String docfile;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetType eamassettype;

    /**
     * 
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    private cn.ibizlab.assetmanagement.core.asset.domain.EAMDocumentType eamdocumenttype;



    /**
     * 设置 [文档名称]
     */
    public void setEamdocumentname(String eamdocumentname){
        this.eamdocumentname = eamdocumentname ;
        this.modify("eamdocumentname",eamdocumentname);
    }

    /**
     * 设置 [资产类型标识]
     */
    public void setEamassettypeid(String eamassettypeid){
        this.eamassettypeid = eamassettypeid ;
        this.modify("eamassettypeid",eamassettypeid);
    }

    /**
     * 设置 [文档编号]
     */
    public void setDocumentnumber(String documentnumber){
        this.documentnumber = documentnumber ;
        this.modify("documentnumber",documentnumber);
    }

    /**
     * 设置 [文档类型标识]
     */
    public void setEamdocumenttypeid(String eamdocumenttypeid){
        this.eamdocumenttypeid = eamdocumenttypeid ;
        this.modify("eamdocumenttypeid",eamdocumenttypeid);
    }

    /**
     * 设置 [内容]
     */
    public void setContent(String content){
        this.content = content ;
        this.modify("content",content);
    }

    /**
     * 设置 [文件]
     */
    public void setDocfile(String docfile){
        this.docfile = docfile ;
        this.modify("docfile",docfile);
    }


}


