package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMDocumentType;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMDocumentTypeSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMDocumentType] 服务对象接口
 */
public interface IEAMDocumentTypeService extends IService<EAMDocumentType>{

    boolean create(EAMDocumentType et) ;
    void createBatch(List<EAMDocumentType> list) ;
    boolean update(EAMDocumentType et) ;
    void updateBatch(List<EAMDocumentType> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMDocumentType get(String key) ;
    EAMDocumentType getDraft(EAMDocumentType et) ;
    boolean checkKey(EAMDocumentType et) ;
    boolean save(EAMDocumentType et) ;
    void saveBatch(List<EAMDocumentType> list) ;
    Page<EAMDocumentType> searchDefault(EAMDocumentTypeSearchContext context) ;
    Page<EAMDocumentType> searchTop(EAMDocumentTypeSearchContext context) ;
    List<EAMDocumentType> selectByPeamdocumenttypeid(String eamdocumenttypeid) ;
    void removeByPeamdocumenttypeid(String eamdocumenttypeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMDocumentType> getEamdocumenttypeByIds(List<String> ids) ;
    List<EAMDocumentType> getEamdocumenttypeByEntities(List<EAMDocumentType> entities) ;
}


